package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_condition_statistics.git/db/model"
	zhios_condition_statistics_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_condition_statistics.git/utils"
	"fmt"
	"time"
	"xorm.io/xorm"
)

func OrderRelateListByTimeByStateNew(Db *xorm.Engine, uid interface{}, task *model.UserLevelUpgradeTask) (float64, error) {
	timeStr := " and olr.level=0 "
	if task.TaskType == 25 {
		timeStr = " and olr.level>=0 "
	}
	t := time.Now()
	stime := time.Date(t.Year(), t.Month(), t.Day()-task.WithinDays, t.Hour(), 0, 0, 0, t.Location())
	etime := t
	state := "1,2,3,5"
	timeStr = ""
	if task.WithinDays > 0 {
		timeStr += " and ("
		timeStr += " (ol.confirm_at>=" + zhios_condition_statistics_utils.Int64ToStr(stime.Unix()) + " and  ol.confirm_at<=" + zhios_condition_statistics_utils.Int64ToStr(etime.Unix()) + ")"
		timeStr += " or (pco.created_at>=" + zhios_condition_statistics_utils.Int64ToStr(stime.Unix()) + " and  pco.created_at<=" + zhios_condition_statistics_utils.Int64ToStr(etime.Unix()) + ")"
		timeStr += " or (dol.create_at>=" + zhios_condition_statistics_utils.Int64ToStr(stime.Unix()) + " and  dol.create_at<=" + zhios_condition_statistics_utils.Int64ToStr(etime.Unix()) + ")"
		timeStr += " or (ro.create_time>=" + zhios_condition_statistics_utils.Int64ToStr(stime.Unix()) + " and  ro.create_time<=" + zhios_condition_statistics_utils.Int64ToStr(etime.Unix()) + ")"
		timeStr += " or (pso.create_time>=" + zhios_condition_statistics_utils.Int64ToStr(stime.Unix()) + " and  pso.create_time<=" + zhios_condition_statistics_utils.Int64ToStr(etime.Unix()) + ")"
		timeStr += " )"
	}
	if task.OrdState == 1 { //已付款
		state = "0,1,2,3,5"
		timeStr = ""
		if task.WithinDays > 0 {
			timeStr += " and ("
			timeStr += " (ol.create_at>=" + zhios_condition_statistics_utils.Int64ToStr(stime.Unix()) + " and  ol.create_at<=" + zhios_condition_statistics_utils.Int64ToStr(etime.Unix()) + ")"
			timeStr += " or (pco.created_at>=" + zhios_condition_statistics_utils.Int64ToStr(stime.Unix()) + " and  pco.created_at<=" + zhios_condition_statistics_utils.Int64ToStr(etime.Unix()) + ")"
			timeStr += " or (dol.create_at>=" + zhios_condition_statistics_utils.Int64ToStr(stime.Unix()) + " and  dol.create_at<=" + zhios_condition_statistics_utils.Int64ToStr(etime.Unix()) + ")"
			timeStr += " or (ro.create_time>=" + zhios_condition_statistics_utils.Int64ToStr(stime.Unix()) + " and  ro.create_time<=" + zhios_condition_statistics_utils.Int64ToStr(etime.Unix()) + ")"
			timeStr += " or (pso.create_time>=" + zhios_condition_statistics_utils.Int64ToStr(stime.Unix()) + " and  pso.create_time<=" + zhios_condition_statistics_utils.Int64ToStr(etime.Unix()) + ")"
			timeStr += " )"
		}
	}
	if task.OrdState == 3 {
		state = ""
		timeStr = ""
		if task.WithinDays > 0 {
			timeStr += " and ("
			timeStr += " (ol.settle_at>=" + zhios_condition_statistics_utils.Int64ToStr(stime.Unix()) + " and  ol.settle_at<=" + zhios_condition_statistics_utils.Int64ToStr(etime.Unix()) + ")"
			timeStr += " or (pco.settle_at>=" + zhios_condition_statistics_utils.Int64ToStr(stime.Unix()) + " and  pco.settle_at<=" + zhios_condition_statistics_utils.Int64ToStr(etime.Unix()) + ")"
			timeStr += " or (dol.settle_at>=" + zhios_condition_statistics_utils.Int64ToStr(stime.Unix()) + " and  dol.settle_at<=" + zhios_condition_statistics_utils.Int64ToStr(etime.Unix()) + ")"
			timeStr += " or (ro.settle_at>=" + zhios_condition_statistics_utils.Int64ToStr(stime.Unix()) + " and  ro.settle_at<=" + zhios_condition_statistics_utils.Int64ToStr(etime.Unix()) + ")"
			timeStr += " or (pso.settle_time>=" + zhios_condition_statistics_utils.Int64ToStr(stime.Unix()) + " and  pso.settle_time<=" + zhios_condition_statistics_utils.Int64ToStr(etime.Unix()) + ")"
			timeStr += " )"
		}
		timeStr += " and (ol.settle_at>0 or pco.settle_at>0 or dol.settle_at>0 or ro.settle_at>0 or pso.settle_time>0)"
	}

	var sum float64 = 0

	// 统计预估 (预估包含结算部分且是有效订单）
	sqlTpl := `SELECT cast(SUM(LEFT(olr.amount,LENGTH(olr.amount)-2)) as decimal(50,4)) AS amount
FROM ord_list_relate olr
        LEFT JOIN ord_list ol ON olr.oid = ol.ord_id
		LEFT JOIN privilege_card_ord pco ON olr.oid =pco.ord_id
		LEFT JOIN duoyou_ord_list dol ON olr.oid =dol.oid
		LEFT JOIN recharge_order ro ON olr.oid =ro.oid
		LEFT JOIN playlet_sale_order pso ON olr.oid =pso.custom_oid
WHERE olr.uid = ?  %s AND (ol.state in(%s) or pco.state=1 or dol.id>0 or ro.status<>'已退款' or pso.status<>'订单退款');
`
	sqlTpl = fmt.Sprintf(sqlTpl, timeStr, state)
	todayResult, err := QueryNativeString(Db, sqlTpl, uid)
	if err == nil && len(todayResult) > 0 {
		sum = zhios_condition_statistics_utils.StrToFloat64(todayResult[0]["amount"])
	}

	return sum, nil
}

func MallOrderRelateListByTimeByStateNew(Db *xorm.Engine, uid interface{}, task *model.UserLevelUpgradeTask) (float64, error) {
	timeStr := " and olr.level=0 "
	if task.TaskType == 25 {
		timeStr = " and olr.level>=0 "
	}
	t := time.Now()
	stime := time.Date(t.Year(), t.Month(), t.Day()-task.WithinDays, t.Hour(), 0, 0, 0, t.Location())
	etime := t
	state := "1,2,3"
	timeStr = ""
	if task.WithinDays > 0 {
		timeStr += " and ol.confirm_time>='" + stime.Format("2006-01-02 15:04:05") + "' and  ol.confirm_time<='" + etime.Format("2006-01-02 15:04:05") + "'"
	}
	if task.OrdState == 1 { //已付款
		state = "0,1,2,3,5"
		timeStr = ""
		if task.WithinDays > 0 {
			timeStr += " and ol.create_time>='" + stime.Format("2006-01-02 15:04:05") + "' and  ol.create_time<='" + etime.Format("2006-01-02 15:04:05") + "'"
		}
	}
	if task.OrdState == 3 {
		state = ""
		timeStr = ""
		if task.WithinDays > 0 {
			timeStr += " and ol.settle_time>='" + stime.Format("2006-01-02 15:04:05") + "' and  ol.settle_time<='" + etime.Format("2006-01-02 15:04:05") + "'"
		}
		timeStr += " and ol.settle_time is not null"
	}

	var sum float64 = 0

	// 统计预估 (预估包含结算部分且是有效订单）
	sqlTpl := `SELECT cast(SUM(olr.amount) as decimal(50,6)) AS amount
FROM mall_ord_list_relate olr
         LEFT JOIN mall_ord ol ON olr.oid = ol.ord_id
WHERE olr.uid = ? %s AND ol.state IN (%s);
`
	sqlTpl = fmt.Sprintf(sqlTpl, timeStr, state)
	todayResult, err := QueryNativeString(Db, sqlTpl, uid)
	if err == nil && len(todayResult) > 0 {
		sum = zhios_condition_statistics_utils.StrToFloat64(todayResult[0]["amount"])
	}

	return sum, nil
}
func O2oOrderRelateListByTimeByStateNew(Db *xorm.Engine, uid interface{}, task *model.UserLevelUpgradeTask) (float64, error) {
	timeStr := " and olr.level=0 "
	if task.TaskType == 25 {
		timeStr = " and olr.level>=0 "
	}
	t := time.Now()
	stime := time.Date(t.Year(), t.Month(), t.Day()-task.WithinDays, t.Hour(), 0, 0, 0, t.Location())
	etime := t
	state := "1,2,3"
	timeStr = ""
	if task.WithinDays > 0 {
		timeStr += " and ("
		timeStr += " (ol.confirm_time>='" + stime.Format("2006-01-02 15:04:05") + "' and  ol.confirm_time<='" + etime.Format("2006-01-02 15:04:05") + "')"
		timeStr += " (optm.create_time>='" + stime.Format("2006-01-02 15:04:05") + "' and  optm.create_time<='" + etime.Format("2006-01-02 15:04:05") + "')"
		timeStr += " )"
	}
	if task.OrdState == 1 { //已付款
		state = "0,1,2,3,5"
		timeStr = ""
		if task.WithinDays > 0 {
			timeStr += " and ("
			timeStr += " (ol.create_time>='" + stime.Format("2006-01-02 15:04:05") + "' and  ol.create_time<='" + etime.Format("2006-01-02 15:04:05") + "')"
			timeStr += " (optm.create_time>='" + stime.Format("2006-01-02 15:04:05") + "' and  optm.create_time<='" + etime.Format("2006-01-02 15:04:05") + "')"
			timeStr += " )"
		}
	}
	if task.OrdState == 3 {
		state = ""
		timeStr = ""
		if task.WithinDays > 0 {
			timeStr += " and ("
			timeStr += " (ol.settle_time>='" + stime.Format("2006-01-02 15:04:05") + "' and  ol.settle_time<='" + etime.Format("2006-01-02 15:04:05") + "')"
			timeStr += " (optm.settle_time>='" + stime.Format("2006-01-02 15:04:05") + "' and  optm.settle_time<='" + etime.Format("2006-01-02 15:04:05") + "')"
			timeStr += " )"
		}
		timeStr += " and (ol.settle_time is not null or optm.settle_time is not null)"
	}

	var sum float64 = 0

	// 统计预估 (预估包含结算部分且是有效订单）
	sqlTpl := `SELECT cast(SUM(olr.amount) as decimal(50,6)) AS amount
FROM mall_ord_list_relate olr
         LEFT JOIN o2o_ord ol ON olr.oid = ol.ord_id
         LEFT JOIN o2o_pay_to_merchant optm ON optm.pay_id = olr.oid
WHERE olr.uid = ? %s AND (ol.state IN (%s) or optm.state>=1);
`
	sqlTpl = fmt.Sprintf(sqlTpl, timeStr, state)
	todayResult, err := QueryNativeString(Db, sqlTpl, uid)
	if err == nil && len(todayResult) > 0 {
		sum = zhios_condition_statistics_utils.StrToFloat64(todayResult[0]["amount"])
	}

	return sum, nil
}
func B2cOrderRelateListByTimeByStateNew(Db *xorm.Engine, uid interface{}, task *model.UserLevelUpgradeTask) (float64, error) {
	timeStr := " and olr.level=0 "
	if task.TaskType == 25 {
		timeStr = " and olr.level>=0 "
	}
	t := time.Now()
	stime := time.Date(t.Year(), t.Month(), t.Day()-task.WithinDays, t.Hour(), 0, 0, 0, t.Location())
	etime := t
	state := "1,2,3"
	timeStr = ""
	if task.WithinDays > 0 {
		timeStr += " and ol.confirm_time>='" + stime.Format("2006-01-02 15:04:05") + "' and  ol.confirm_time<='" + etime.Format("2006-01-02 15:04:05") + "'"
	}
	if task.OrdState == 1 { //已付款
		state = "0,1,2,3,5"
		timeStr = ""
		if task.WithinDays > 0 {
			timeStr += " and ol.create_time>='" + stime.Format("2006-01-02 15:04:05") + "' and  ol.create_time<='" + etime.Format("2006-01-02 15:04:05") + "'"
		}
	}
	if task.OrdState == 3 {
		state = ""
		timeStr = ""
		if task.WithinDays > 0 {
			timeStr += " and ol.settle_time>='" + stime.Format("2006-01-02 15:04:05") + "' and  ol.settle_time<='" + etime.Format("2006-01-02 15:04:05") + "'"
		}
		timeStr += " and ol.settle_time is not null"
	}

	var sum float64 = 0

	// 统计预估 (预估包含结算部分且是有效订单）
	sqlTpl := `SELECT cast(SUM(olr.amount) as decimal(50,6)) AS amount
FROM mall_ord_list_relate olr
        LEFT  JOIN b2c_ord ol ON olr.oid = ol.ord_id
WHERE olr.uid = ?  %s AND ol.state IN (%s);
`
	sqlTpl = fmt.Sprintf(sqlTpl, timeStr, state)
	todayResult, err := QueryNativeString(Db, sqlTpl, uid)
	if err == nil && len(todayResult) > 0 {
		sum = zhios_condition_statistics_utils.StrToFloat64(todayResult[0]["amount"])
	}

	return sum, nil
}
