package model

import (
	"time"
)

type UserLevelAudit struct {
	Id             int       `json:"id" xorm:"not null pk autoincr comment('自增ID') INT(10)"`
	Uid            int       `json:"uid" xorm:"not null default 0 comment('uid') index INT(10)"`
	CurrentLevelId int       `json:"current_level_id" xorm:"not null default 0 comment('用户当前等级id') INT(10)"`
	NextLevelId    int       `json:"next_level_id" xorm:"not null default 0 comment('要升级到的等级id（续费情况id=当前等级id）') INT(10)"`
	ConditionType  int       `json:"condition_type" xorm:"not null default 0 comment('升级方式：1无条件升级 2条件升级') TINYINT(1)"`
	AutoAudit      int       `json:"auto_audit" xorm:"not null default 0 comment('自动审核：0关闭（手动审核），1开启（自动审核）') TINYINT(1)"`
	DateType       int       `json:"date_type" xorm:"not null default 0 comment('1:包月,2:包季,3:包年,4:永久,0:非付费升级') TINYINT(1)"`
	State          int       `json:"state" xorm:"not null default 1 comment('审核状态:1待审核；2审核通过；3审核拒绝') TINYINT(1)"`
	CreateAt       time.Time `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') TIMESTAMP"`
	UpdateAt       time.Time `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('更新时间') TIMESTAMP"`
	RelateOid      int64     `json:"relate_oid" xorm:"comment('关联的订单id（如果是付费）') BIGINT(22)"`
	Reason         string    `json:"reason" xorm:"comment('拒绝理由') TEXT"`
	LevelDate      int       `json:"level_date" xorm:"not null default 0 comment('会员有效期：0永久；其他为x月') INT(11)"`
}
